r49@yurie: data | 2005-02-21 01:39:35 +0200
[clinton/abcde.git] / abcde
diff --git a/abcde b/abcde
index ea84e47..bd13e20 100755 (executable)
--- a/abcde
+++ b/abcde
 # Copyright for this work is to expire January 1, 2010, after which it
 # shall be public domain.
 
-VERSION=2.2pre2
+VERSION="2.2.4"
 
 usage ()
 {
 echo "This is abcde v$VERSION."
 echo "Usage: abcde [options] [tracks]"
 echo "Options:"
-echo "-1    Encode the whole CD in a single file"
-echo "-a    Actions to perform (cddb,read,normalize,encode,tag,move,playlist,clean)"
-echo "-b    Batch mode: enable album normalization and nogap encoding"
-echo "-c    Specify a configuration file (overrides system and user config files)"
-echo "-C    Specify discid to resume from (only needed if you no longer have the cd)"
-echo "-d    Specify CDROM device to grab"
-echo "-D    Debugging mode (equivalent to sh -x abcde)"
-#echo "-f    Force the use of a local CDDB entry. Otherwise use an empty template"
-echo "-h    This help information"
+echo "-1     Encode the whole CD in a single file"
+echo "-a <action1[,action2]...>"
+echo "       Actions to perform (cddb,read,normalize,encode,tag,move,playlist,clean)"
+#echo "-A     Experimental actions (retag, transcode)"
+echo "-b     Batch mode: enable album normalization and nogap encoding"
+echo "-c <file>"
+echo "       Specify a configuration file (overrides system and user config files)"
+echo "-C <discid#>"
+echo "       Specify discid to resume from (only needed if you no longer have the cd)"
+echo "-d <device>"
+echo "       Specify CDROM device to grab"
+echo "-D     Debugging mode (equivalent to sh -x abcde)"
+echo "-h     This help information"
 #echo "-i    Tag files while encoding, when possible (local only) -NWY-"
-echo "-j    Number of encoder processes to run at once"
-echo "-k    Keep the wav tracks for later use"
-echo "-l    Use low disk space algorithm"
-echo "-L    Use local CDDB storage directory"
-echo "-n    No lookup. Don't query CDDB, just create and use template"
-echo "-N    Noninteractive. Never prompt for anything"
-echo "-m    Modify playlist to include CRLF endings, to comply with some players"
-echo "-o    Output file type(s) (ogg,mp3,flac,spx,mpc). Defaults to ogg"
-echo "-p    Pad track numbers with 0's (if less than 10 tracks)"
-echo "-r    [host1,host2...] Also encode on these remote hosts"
-echo "-s    Start the track numbering at a given number"
-echo "-S    Set the CD speed (if possible)"
+echo "-j <#> Number of encoder processes to run at once (localhost)"
+echo "-k     Keep the wav tracks for later use"
+echo "-l     Use low disk space algorithm"
+echo "-L     Use local CDDB storage directory"
+echo "-n     No lookup. Don't query CDDB, just create and use template"
+echo "-N     Noninteractive. Never prompt for anything"
+echo "-m     Modify playlist to include CRLF endings, to comply with some players"
+echo "-M     Create a CUE file"
+echo "-o <type1[,type2]...>"
+echo "       Output file type(s) (ogg,mp3,flac,spx,mpc). Defaults to ogg"
+echo "-p     Pad track numbers with 0's (if less than 10 tracks)"
+echo "-P     Use UNIX pipes to read+encode without wav files"
+echo "-r <host1[,host2]...>"
+echo "       Also encode on these remote hosts"
+echo "-R     Add replaygain values to the tag info (only for ogg,flac)"
+echo "-S <#> Set the CD speed"
 #echo "-t    File types to preprocess (wav)"
 #echo "-T    Set postprocessing options"
-echo "-v    Show version number and exit"
-echo "-V    Be a bit more verbose about what is happening behind the scenes"
-echo "-x    Eject CD after all tracks are read"
+echo "-t <#> Start the track numbering at a given number"
+echo "-T <#> Same as -t but modifies tag numbering"
+echo "-v     Show version number and exit"
+echo "-V     Be a bit more verbose about what is happening behind the scenes"
+echo "-x     Eject CD after all tracks are read"
+echo "-w <comment>"
+echo "       Add a comment to the CD tracks"
+echo "-W <#> Contatenate CDs: -T #01 -w \"CD #\"" 
+echo ""
 echo "Tracks is a space-delimited list of tracks to grab."
 echo "Ranges specified with hyphens are allowed."
 }
@@ -273,6 +287,13 @@ do_tag ()
 {
        COMMENTOUTPUT="$(eval echo ${COMMENT})"
        run_command '' echo "Tagging track $1 of $TRACKS: $TRACKNAME..."
+       # If we want to start the tracks with a given number, we need to modify the
+       # TRACKNUM value before evaluation
+       if [ -n "$STARTTRACKNUMBER" -a -n "$STARTTRACKNUMBERTAG" ] ; then
+               # Get the trackpadding from the current track
+               CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
+               TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - 1 ))
+       fi
        for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
        do
        case "$OUTPUT" in
@@ -301,6 +322,7 @@ do_tag ()
                                        echo GENRE="$CDGENRE"
                                fi      
                                echo TRACKNUMBER=$1
+                               echo CDDB=$CDDBDISCID
                                if [ "$(eval echo ${COMMENT})" != "" ]; then
                                        case "$COMMENTOUTPUT" in
                                                *=*) echo "$COMMENTOUTPUT";;
@@ -329,14 +351,15 @@ do_tag ()
                        if [ -n "$CDGENRE" ]; then
                        echo GENRE="$CDGENRE"
                 fi     
+               echo TRACKNUMBER=${TRACKNUM:-$1}
+               echo CDDB=$CDDBDISCID
                if [ "$(eval echo ${COMMENT})" != "" ]; then
                        case "$COMMENTOUTPUT" in
                                *=*) echo "$COMMENTOUTPUT";;
                                *)   echo COMMENT="$COMMENTOUTPUT";;
                        esac    
                fi
-               echo TRACKNUMBER=$1
-                ) | run_command tagtrack-$1 $METAFLAC --import-vc-from=- --no-utf8-convert "$ABCDETEMPDIR/track$1.$OUTPUT"
+                ) | run_command tagtrack-$1 $METAFLAC --import-tags-from=- --no-utf8-convert "$ABCDETEMPDIR/track$1.$OUTPUT"
                ;;
        spx)
                run_command tagtrack-$1 true
@@ -661,7 +684,7 @@ do_move ()
                ALBUMFILE=$(mungefilename "$DALBUM")
                ARTISTFILE=$(mungefilename "$TRACKARTIST")
                TRACKFILE=$(mungefilename "$TRACKNAME")
-               GENRE=$(echo $CDGENRE | tr "[:upper:]" "[:lower:]")
+               GENRE=$(mungegenre "$GENRE")
                YEAR=$(echo $CDYEAR)
                # If we want to start the tracks with a given number, we need to modify the
                # TRACKNUM value before evaluation
@@ -701,7 +724,7 @@ do_playlist ()
                for LASTTRACK in $TRACKQUEUE; do :; done
                ALBUMFILE=$(mungefilename "$DALBUM")
                ARTISTFILE=$(mungefilename "$DARTIST")
-               GENRE=$(echo $CDGENRE | tr "[:upper:]" "[:lower:]")
+               GENRE=$(mungegenre "$GENRE")
                if [ "$VARIOUSARTISTS" = "y" ] ; then
                        PLAYLISTFILE=$(eval echo $VAPLAYLISTFORMAT)
                else
@@ -710,8 +733,6 @@ do_playlist ()
                FINALPLAYLISTDIR=$(dirname "$OUTPUTDIR/$PLAYLISTFILE")
                mkdir -p "$FINALPLAYLISTDIR"
                if [ -s "$OUTPUTDIR/$PLAYLISTFILE" ]; then
-                       ## FIXME ## Erase, Append or Keep the playlist?
-                       #echo -n "Erase any existing playlist file? [y/n] (y): " >&2
                        echo -n "Erase, Append to, or Keep the existing playlist file? [e/a/k] (e): " >&2
                        if [ "$INTERACTIVE" = "y" ]; then
                                while [ "$DONE" != "y" ]; do
@@ -737,13 +758,13 @@ do_playlist ()
                        do
                                # Shares some code with do_move since the filenames have to match
                                CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
-                               TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
+                               TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2 -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')
                                splitvarious
                                TRACKFILE=$(mungefilename "$TRACKNAME")
                                ARTISTFILE=$(mungefilename "$TRACKARTIST")
                                # If we want to start the tracks with a given number, we need to modify the
                                # TRACKNUM value before evaluation
-                               if [ -n $STARTTRACKNUMBER ] ; then
+                               if [ -n "$STARTTRACKNUMBER" ] ; then
                                        # Get the trackpadding from the current track
                                        CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
                                        TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - 1 ))
@@ -786,6 +807,10 @@ do_playlist ()
 do_discid ()
 {
        # Query the CD to get the track info, unless the user specified -C
+       # or we are using some actions which do not need the CDDB data at all
+       #if [ ! X"$EXPACTIONS" = "X" ]; then
+       #       :
+       #elif [ -z "$DISCID" ]; then
        if [ -z "$DISCID" ]; then
                vecho -n "Getting CD track info... "
                TRACKINFO=$($CDDISCID $CDROM)
@@ -804,6 +829,9 @@ do_discid ()
        # it later.
 
        # get the number of digits to pad TRACKNUM with - we'll use this later
+       # a CD can only hold 99 tracks, but since we support a feature for starting
+       # numbering the tracks from a given number, we might need to set it as a
+       # variable for the user to define... or obtain it somehow.
        if [ "$PADTRACKS" = "y" ] ; then
                TRACKNUMPADDING=2
        fi
@@ -815,7 +843,12 @@ do_discid ()
                                cdparanoia|debug)
                                        if [ "$WEHAVEACD" = "y" ]; then
                                                vecho "Querying the CD for audio tracks..."
-                                               TRACKS=$( $CDROMREADER -Q 2>&1 | egrep '^[[:space:]]+[[:digit:]]' | tail -n 1 |  awk '{print $1}' | tr -d "." | tr '\n' ' ' )
+                                               CDPARANOIAOUTPUT=$( $CDROMREADER -d $CDROM -Q --verbose 2>&1 )
+                                               RET=$?
+                                               if [ ! "$RET" = "0" ];then
+                                                       echo "Warning: Something went wrong while querying the CD... Maybe a DATA CD?"
+                                               fi
+                                               TRACKS=$( echo $CDPARANOIAOUTPUT | egrep '^[[:space:]]+[[:digit:]]' | tail -n 1 |  awk '{print $1}' | tr -d "." | tr '\n' ' ' )
                                                CDPARANOIAAUDIOTRACKS="$TRACKS"
                                        else
                                                if [ -f "$ABCDETEMPDIR/status" ] && checkstatus cdparanoia-audio-tracks ; then
@@ -830,6 +863,10 @@ do_discid ()
                else
                        TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
                fi
+               if echo "$TRACKS" | grep [[:digit:]] > /dev/null 2>&1 ;then :;else
+                       echo "The disc does not contain any tracks. Giving up..."
+                       exit 0
+               fi
                echo -n "Grabbing entire CD - tracks: "
                if [ ! "$PADTRACKS" = "y" ] ; then
                        TRACKNUMPADDING=$(echo -n $TRACKS | wc -c | tr -d ' ')
@@ -868,7 +905,6 @@ do_discid ()
        # We have the discid, create a temp directory after it to store all the temp
        # info
 
-       ABCDETEMPDIR="$WAVOUTPUTDIR/abcde.$(echo $TRACKINFO | cut -f1 -d' ')"
        if [ -e "$ABCDETEMPDIR" ]; then
                echo -n "abcde: attempting to resume from $ABCDETEMPDIR"
                # It already exists, see if it's a directory
@@ -935,46 +971,23 @@ do_discid ()
                fi
                cat /dev/null > "$ABCDETEMPDIR/status"
        fi
-       
+       if [ X"$CUEFILE" = "Xy" -a X"$WEHAVEACD" = "Xy" ]; then
+               if checkstatus cuefile ; then :; else
+                       $MKCUE $MKCUEOPTS > $ABCDETEMPDIR/cue-$(echo $TRACKINFO | cut -f1 -d' ').txt
+                       echo cuefile >> "$ABCDETEMPDIR/status"
+               fi
+       fi
        # If we got the CDPARANOIA status and it is not recorded, save it now
-       ## FIXME ## ! is non-portable
-       if [ -n "$CDPARANOIAAUDIOTRACKS" ] && ! checkstatus cdparanoia-audio-tracks; then
-               if echo "$CDPARANOIAAUDIOTRACKS" >> "$ABCDETEMPDIR/cdparanoia-audio-tracks"; then
-                       echo "cdparanoia-audio-tracks" >> "$ABCDETEMPDIR/status"
+       if [ -n "$CDPARANOIAAUDIOTRACKS" ]; then
+               if checkstatus cdparanoia-audio-tracks; then :; else
+                       if echo "$CDPARANOIAAUDIOTRACKS" >> "$ABCDETEMPDIR/cdparanoia-audio-tracks"; then
+                               echo "cdparanoia-audio-tracks" >> "$ABCDETEMPDIR/status"
+                       fi
                fi
        fi
        
        # Create the discid file
        echo "$TRACKINFO" > "$ABCDETEMPDIR/discid"
-
-       # Determine what actions are to be done from $ACTIONS and set the
-       # following environment variables for them:
-       DOCDDB=n
-       DOREAD=n
-       DONORMALIZE=n
-       DOPREPROCESS=n
-       DOENCODE=n
-       DOPOSTPROCESS=n
-       DOTAG=n
-       DOMOVE=n
-       DOPLAYLIST=n
-       DOCLEAN=n
-
-       for ACTION in $(echo $ACTIONS | tr , \ )
-       do
-               case $ACTION in
-               cddb) DOCDDB=y;;
-               read) DOREAD=y;;
-               normalize) DONORMALIZE=y; DOREAD=y;;
-               preprocess) DOPREPROCESS=y; DOREAD=y;;
-               encode) DOENCODE=y; DOREAD=y;;
-               postprocess) DOPREPROCESS=y; DOENCODE=y; DOREAD=y;;
-               tag) DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
-               move) DOMOVE=y; DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
-               playlist) DOCDDB=y; DOPLAYLIST=y;;
-               clean) DOCLEAN=y;;
-               esac
-       done
 }
 
 # do_cddbparse
@@ -1008,36 +1021,35 @@ do_localcddb ()
                USELOCALRESP="y"
                
                # If the user has selected to check a local CDDB repo, we proceed with it
-               if [ "$CDDBUSELOCAL" = "y" ]; then
-                       if [ -r "${CDDBLOCALFILE}" ]; then
-                               # List out disc title/author and contents
-                               do_cddbparse "${CDDBLOCALFILE}"
-                               echo -n "Locally cached CDDB entry found, use it? [y/n] (y): "
-                               if [ "$INTERACTIVE" = "y" ]; then
+               if [ -r "${CDDBLOCALFILE}" ]; then
+                       # List out disc title/author and contents
+                       do_cddbparse "${CDDBLOCALFILE}"
+                       echo -n "Locally cached CDDB entry found, use it? [y/n] (y): "
+                       if [ "$INTERACTIVE" = "y" ]; then
+                               read USELOCALRESP
+                               while [ "$USELOCALRESP" != "y" ] && [ "$USELOCALRESP" != "n" ] && [ "$USELOCALRESP" != "" ] ; do
+                                       echo -n 'Invalid selection. Please answer "y" or "n": '
                                        read USELOCALRESP
-                                       while [ "$USELOCALRESP" != "y" ] && [ "$USELOCALRESP" != "n" ] && [ "$USELOCALRESP" != "" ] ; do
-                                               echo -n 'Invalid selection. Please answer "y" or "n": '
-                                               read USELOCALRESP
-                                       done
-                                       [ x"$USELOCALRESP" = "x" ] && USELOCALRESP="y"
-                               else
-                                       echo "y" >&2
-                               fi
-                               if [ "$USELOCALRESP" = "y" ]; then
-                               #echo "Using local copy of CDDB data"
-                                       cp "${CDDBLOCALFILE}" "$ABCDETEMPDIR/cddbread.1"
-                                       echo 999 > "$ABCDETEMPDIR/cddbquery" # Assuming 999 isn't used by CDDB
-                                       echo cddb-readcomplete >> "$ABCDETEMPDIR/status"
-                                       do_cddbparse "${CDDBLOCALFILE}" > "$ABCDETEMPDIR/cddbchoices"
-                                       echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
-                                       CDDBLOCALSUCCESS="y"
-                               else
-                                       #echo "Not using local copy of CDDB data"
-                                       CDDBLOCALSUCCESS="n"
-                               fi
+                               done
+                               [ x"$USELOCALRESP" = "x" ] && USELOCALRESP="y"
+                       else
+                               echo "y" >&2
+                       fi
+                       if [ "$USELOCALRESP" = "y" ]; then
+                       #echo "Using local copy of CDDB data"
+                               cp "${CDDBLOCALFILE}" "$ABCDETEMPDIR/cddbread.1"
+                               echo 999 > "$ABCDETEMPDIR/cddbquery" # Assuming 999 isn't used by CDDB
+                               echo cddb-readcomplete >> "$ABCDETEMPDIR/status"
+                               do_cddbparse "${CDDBLOCALFILE}" > "$ABCDETEMPDIR/cddbchoices"
+                               echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
+                               CDDBLOCALSUCCESS="y"
                        else
+                               #echo "Not using local copy of CDDB data"
                                CDDBLOCALSUCCESS="n"
                        fi
+                       CDDBLOCALSUCCESS="y"
+               else
+                       CDDBLOCALSUCCESS="n"
                fi
        fi
 }
@@ -1269,6 +1281,7 @@ do_cddbedit ()
                                        # I'll take CDDB read #3 for $400, Alex
                                        echo -n "Which entry would you like abcde to use (0 for none)? [0-$CDDBCHOICES]: " >&2
                                        read CDDBCHOICE
+                                       [ X"$CDDBCHOICE" = "X" ] && CDDBCHOICE=1
                                        # Make sure we get a valid choice
                                        CDCHOICENUM=$(echo $CDDBCHOICE | xargs printf %d 2>/dev/null)
                                        while [ $CDCHOICENUM -lt 0 ] || [ $CDCHOICENUM -gt $CDDBCHOICES ]; do
@@ -1299,6 +1312,10 @@ do_cddbedit ()
                                if [ "$USELOCALRESP" = "y" ]; then :; else
                                        if [ -n "$CHOICE" ] ; then
                                                case $CDDBCHOICES in
+                                                       0) 
+                                                       UNKNOWNDISK=y
+                                                       echo "Selected template."
+                                                       ;;
                                                        1) cat "$ABCDETEMPDIR/cddbchoices" ;;
                                                        *)
                                                        echo "Selected: #$CHOICE"
@@ -1506,79 +1523,55 @@ do_cddbedit ()
        echo "cddb-edit" >> "$ABCDETEMPDIR/status"
 }
 
-# do_cdread_one [lasttrack] [firsttrack]
-# 
-# Reads the CD in a single track. Live performances, concerts, mixes,... benefit from this.
-do_cdread_one ()
-{
-       # The commands here don't go through run_command because they're never supposed to be silenced
-       # return codes need to be doublechecked anyway, however
-       LASTTRACKNUMBER=$1
-       FIRSTTRACKNUMBER=$2
-       WAVDATA="$ABCDETEMPDIR/track$FIRSTTRACKNUMBER.wav"
-       echo "Grabbing the CD to a single track..." >&2
-       case "$CDROMREADERSYNTAX" in
-               cdparanoia) nice $READNICE $CDROMREADER -d $CDROM "1-" "$WAVDATA" >&2 ;;
-               cdda2wav)
-                       if [ "$OSFLAVOUR" = "OSX" ] ; then
-                               # Hei, we have to unmount the device before running anything like cdda2wav in OSX
-                               disktool -u ${CDROM#/dev/} 0
-                               # Also, in OSX the cdrom device for cdda2wav changes...
-                               CDDA2WAVCDROM="IODVDServices"
-                       elif [ "$OSFLAVOUR" = "FBSD" ] ; then
-                               CDDA2WAVCDROM="$CDROMID"
-                       else
-                               if [ "$CDROMID" = "" ]; then
-                                       CDDA2WAVCDROM="$CDROM"
-                               else
-                                       CDDA2WAVCDROM="$CDROMID"
-                               fi
-                       fi
-                       nice $READNICE $CDROMREADER -D $CDDA2WAVCDROM -t 1+$LASTTRACKNUM "$WAVDATA" >&2 
-                       ;;
-               dagrab) nice $READNICE $CDROMREADER -d $CDROM -f $WAVDATA -v $UTRACKNUM >&2 ;;
-               cddafs)
-                       # Find the track's mounted path
-                       REALTRACKNUM=$(expr $UTRACKNUM + 0)
-                       FILEPATH=$(mount | grep "$CDROM on" | sed 's/^[^ ]* on \(.*\) (.*/\1/')
-                       FILEPATH=$(find "$FILEPATH" | grep "/$REALTRACKNUM ");
-                       # If the file exists, copy it
-                       if [ -e "$FILEPATH" ] ; then
-                               nice $READNICE $CDROMREADER "$FILEPATH" "$WAVDATA" >&2
-                       else
-                               false
-                       fi ;;
-               debug) nice $READNICE $CDROMREADER -d $CDROM -w $UTRACKNUM-[:1] "$WAVDATA" >&2 ;;
-       esac
-       RETURN=$?
-       if [ "$RETURN" != "0" ]; then
-               # Thank goodness errors is only machine-parseable up to the
-               # first colon, otherwise this woulda sucked
-                echo "readtrack-$FIRSTTRACKNUMBER: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
-               return $RETURN
-       else
-               echo readtrack-$FIRSTTRACKNUMBER >> "$ABCDETEMPDIR/status"
-       fi
-}
-
 # do_cdread [tracknumber]
+# do_cdread onetrack [firsttrack] [lasttrack]
 # 
 do_cdread ()
 {
        # The commands here don't go through run_command because they're never supposed to be silenced
        # return codes need to be doublechecked anyway, however
-       UTRACKNUM=$1
+       if [ "$1" = "onetrack" ]; then
+               # FIXME # Add the possibility of grabbing ranges of tracks in onetrack
+               # FIXME # Until then, we grab the whole CD in one track, no matter what
+               # the user said
+               # We need the first and last track for cdda2wav
+               FIRSTTRACK=$2
+               LASTTRACK=$3
+               case "$CDROMREADERSYNTAX" in
+                       cdparanoia) UTRACKNUM="1-" ;;
+                       cdda2wav) UTRACKNUM="1+$LASTRACK" ;;
+                       *) echo "abcde error: $CDROMREADERSYNTAX does not support ONETRACK mode"
+                          exit 1 ;;
+               esac
+       else
+               UTRACKNUM=$1
+       fi
        CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
        WAVDATA="$ABCDETEMPDIR/track$UTRACKNUM.wav"
-       OUTDATA="$ABCDETEMPDIR/track$UTRACKNUM.$OUTPUTTYPE"
        if [ -r "$CDDBDATA" ]; then
                TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
                echo "Grabbing track $UTRACKNUM: $TRACKNAME..." >&2
        else
                echo "Grabbing track $UTRACKNUM..." >&2
        fi
+       if [ "$USEPIPES" = "y" ]; then
+               TEMPARG="PIPE_$CDROMREADERSYNTAX"
+               FILEARG=${!TEMPARG}
+               REDIR=""
+       else
+               case "$CDROMREADERSYNTAX" in
+               ## FIXME ## Find the case for dagrab, to avoid exceptions
+                       dagrab)
+                               FILEARG="-f $WAVDATA"
+                               ;;
+                       *)
+                               FILEARG=$WAVDATA
+                               ;;
+               esac
+               REDIR=">&2"
+       fi
        case "$CDROMREADERSYNTAX" in
-               cdparanoia) nice $READNICE $CDROMREADER -d $CDROM $UTRACKNUM "$WAVDATA" >&2 ;;
+               cdparanoia) nice $READNICE $CDROMREADER -d $CDROM $UTRACKNUM $FILEARG $REDIR ;;
                cdda2wav)
                        if [ "$OSFLAVOUR" = "OSX" ] ; then
                                # Hei, we have to unmount the device before running anything like cdda2wav in OSX
@@ -1594,30 +1587,47 @@ do_cdread ()
                                        CDDA2WAVCDROM="$CDROMID"
                                fi
                        fi
-                       nice $READNICE $CDROMREADER -D $CDDA2WAVCDROM -t $UTRACKNUM "$WAVDATA" >&2 
+                       nice $READNICE $CDROMREADER -D $CDDA2WAVCDROM -t $UTRACKNUM $FILEARG $REDIR
+                       ;;
+               ## FIXME ## We have an exception for dagrab, since it uses -f
+               ## FIXME ## Shall we just use -f $FILEARG ??
+               dagrab) nice $READNICE $CDROMREADER -d $CDROM -v $UTRACKNUM $FILEARG $REDIR
                        ;;
-               dagrab) nice $READNICE $CDROMREADER -d $CDROM -f $WAVDATA -v $UTRACKNUM >&2 ;;
                cddafs)
                        # Find the track's mounted path
                        REALTRACKNUM=$(expr $UTRACKNUM + 0)
-                       FILEPATH=$(mount | grep "$CDROM on" | sed 's/^[^ ]* on \([^(]*\) (.*/\1/')
+                       FILEPATH=$(mount | grep "$CDROM on" | sed 's/^[^ ]* on \(.*\) (.*/\1/')
                        FILEPATH=$(find "$FILEPATH" | grep "/$REALTRACKNUM ");
                        # If the file exists, copy it
                        if [ -e "$FILEPATH" ] ; then
-                               nice $READNICE $CDROMREADER "$FILEPATH" "$WAVDATA" >&2
+                               nice $READNICE $CDROMREADER "$FILEPATH" $FILEARG $REDIR
                        else
                                false
                        fi ;;
-               debug) nice $READNICE $CDROMREADER -d $CDROM -w $UTRACKNUM-[:1] "$WAVDATA" >&2 ;;
+               debug) nice $READNICE $CDROMREADER -d $CDROM -w $UTRACKNUM-[:1] $FILEARG $REDIR
+                       ;;
        esac
        RETURN=$?
-       if [ "$RETURN" != "0" ]; then
+       # If we get some error or we get some missing wav 
+       # (as long as we dont use pipes)
+       if [ "$RETURN" != "0" -o \( ! -s "$WAVDATA" -a X"$USEPIPES" != "Xy" \) ]; then
                # Thank goodness errors is only machine-parseable up to the
                # first colon, otherwise this woulda sucked
-                echo "readtrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
+               if [ "$RETURN" = "0" -a ! -s "$WAVDATA" ]; then
+                       RETURN=73 # fake a return code as cdparanoia return 0 also on aborted reads
+               fi
+               if [ "$USEPIPES" = "y" ]; then
+                       echo "readencodetrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
+               else
+                       echo "readtrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
+               fi
                return $RETURN
        else
-               echo readtrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
+               if [ "$USEPIPES" = "y" ]; then
+                       echo readencodetrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
+               else
+                       echo readtrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
+               fi
        fi
 }
 
@@ -1642,7 +1652,31 @@ if [ x"$EXTRAVERBOSE" != "x" ]; then
 fi
 }
 
+# User-redefinable functions
+# Custom filename munging:
+mungefilename ()
+{
+       echo "$@" | sed s,:,\ -,g | tr \ /\* __+ | tr -d \'\"\?\[:cntrl:\]
+}
+
+# Custom genre munging:
+mungegenre ()
+{
+       echo $CDGENRE | tr "[:upper:]" "[:lower:]"
+}
+
+# pre_read
+# Empty pre_read function, to be defined in the configuration file.
+pre_read ()
+{
+:
+}
+
+###############################################################################
+# End of functions
+#
 # Start of execution
+###############################################################################
 
 # Builtin defaults
 CDDBURL="http://freedb.freedb.org/~cddb/cddb.cgi"
@@ -1659,6 +1693,7 @@ OGGENCODERSYNTAX=default
 FLACENCODERSYNTAX=default
 SPEEXENCODERSYNTAX=default
 MPPENCODERSYNTAX=default
+NORMALIZERSYNTAX=default
 
 OUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${TRACKNUM}.${TRACKFILE}'
 # Use the following VAOUTPUTFORMAT to revert to 2.0.x VA format:
@@ -1678,7 +1713,6 @@ READNICE=10
 DISTMP3NICE=10
 VARIOUSARTISTS=n
 VARIOUSARTISTSTYLE=forward
-NORMALIZERSYNTAX=default
 KEEPWAVS=n
 PADTRACKS=n
 CDDBCOPYLOCAL="n"
@@ -1720,8 +1754,10 @@ MD5SUM=md5sum
 DISTMP3=distmp3
 VORBISCOMMENT=vorbiscomment
 METAFLAC=metaflac
-NORMALIZE=normalize
+NORMALIZE=normalize-audio
 CDSPEED=eject
+VORBISGAIN=vorbisgain
+MKCUE=mkcue
 
 # Options for programs called from abcde
 # mp3
@@ -1753,6 +1789,7 @@ DISTMP3OPTS=
 NORMALIZEOPTS=
 CDSPEEDOPTS="-x"
 CDSPEEDVALUE=
+MKCUEOPTS=
 
 # Default to one process if -j isn't specified
 MAXPROCS=1
@@ -1760,20 +1797,6 @@ MAXPROCS=1
 # List of actions to perform - by default, run to completion
 ACTIONS=cddb,read,encode,tag,move,clean
 
-# User-redefinable functions
-# Custom filename munging:
-mungefilename ()
-{
-       echo "$@" | sed s,:,\ -,g | tr \ /\* __+ | tr -d \'\"\?\[:cntrl:\]
-}
-
-# pre_read
-# Empty pre_read function, to be defined in the configuration file.
-pre_read ()
-{
-:
-}
-
 # Asume fetch if under FreeBSD. curl is used for Mac OS X. wget is used for Linux/OpenBSD/NetBSD.
 # Let's use these checkings to determine the OS flavour, which will be used later
 if [ X$(uname) = "XFreeBSD" ] ; then
@@ -1796,6 +1819,7 @@ fi
 # If USEID3 is set to n, no ID3 tagging is done
 CDDBAVAIL=y
 USEID3=y
+USEID3V2=y
 
 if [ -z "$OUTPUTDIR" ]; then
        OUTPUTDIR=$(pwd)
@@ -1815,7 +1839,7 @@ if [ -r $HOME/.abcde.conf ]; then
 fi
 
 # By this time, we need some HTTPGETOPTS already defined.
-# If the user has defined its own, we should not be empty.
+# If the user has defined a non-default HTTPGET method, we should not be empty.
 
 if [ "$HTTPGETOPTS" = "" ] ; then
        case $HTTPGET in
@@ -1845,33 +1869,39 @@ fi
 
 # Parse command line options
 #while getopts 1a:bc:C:d:Dhj:klLnNo:pr:S:t:T:vVx opt ; do
-while getopts 1a:bc:C:d:Dhj:klLnNo:pr:s:S:vVx opt ; do
+while getopts 1a:A:bc:C:d:Dhj:klLmMnNo:pPr:Rs:S:t:T:vVxw:W: opt ; do
        case "$opt" in
                1) ONETRACK=y ;;
                a) ACTIONS="$OPTARG" ;;
+               A) EXPACTIONS="$OPTARG";;
                b) BATCH=y ;;
                c) if [ -e "$OPTARG" ] ; then . "$OPTARG" ; else echo "abcde error: config file \"$OPTARG\" cannot be found." >&2 ; exit 1 ; fi ;;
                C) DISCID="${OPTARG#abcde.}" ;;
                d) CDROM="$OPTARG" ;;
                D) set -x ;;
                h) usage; exit ;;
-               f) FORCECDDBUSELOCAL=y ;;
+#              f) FORCECDDBUSELOCAL=y ;;
                i) INLINETAG=y ;;
                j) MAXPROCS="$OPTARG" ;;
                k) KEEPWAVS=y ;;
                l) LOWDISK=y ;;
-               L) CDDBUSELOCAL="y" ;;
-               n) CDDBAVAIL="n" ;;
-               N) INTERACTIVE="n" ;;
+               L) CDDBUSELOCAL=y ;;
+               n) CDDBAVAIL=n ;;
+               N) INTERACTIVE=n ;;
                m) DOSPLAYLIST=y ;;
+               M) CUEFILE=y ;;
                o) OUTPUTTYPE="$OPTARG" ;;
-               p) PADTRACKS="y" ;;
+               p) PADTRACKS=y ;;
+               P) USEPIPES=y ;;
                r) REMOTEHOSTS="$OPTARG" ;;
+               R) REPLAYGAIN=y ;;
                s) STARTTRACKNUMBER="$OPTARG" ;;
                S) CDSPEEDVALUE="$OPTARG" ;;
-               t) PREPROCESSFORMATS="$OPTARG"
-                  PREPROCESS=y ;;
-               T) POSTPROCESSFORMATS="$OPTARG" ;;
+#              t) PREPROCESSFORMATS="$OPTARG"
+#                 PREPROCESS=y ;;
+#              T) POSTPROCESSFORMATS="$OPTARG" ;;
+               t) STARTTRACKNUMBER="$OPTARG" ;;
+               T) STARTTRACKNUMBER="$OPTARG" ; STARTTRACKNUMBERTAG="y" ;;
                v) 
                   echo "This is abcde v$VERSION."
                   echo "Usage: abcde [options] [tracks]"
@@ -1880,24 +1910,29 @@ while getopts 1a:bc:C:d:Dhj:klLnNo:pr:s:S:vVx opt ; do
                   ;;
                V) EXTRAVERBOSE="y" ;;
                x) EJECTCD="y" ;;
+               w) COMMENT="$OPTARG" ;;
+               W) STARTTRACKNUMBER="${OPTARG}01" ; STARTTRACKNUMBERTAG="y" ; COMMENT="CD${OPTARG}" ;;
                ?) usage; exit ;;
        esac
 done
 
 shift $(($OPTIND - 1))
 
-# Decide if we can continue. TO_REMOVE as soon as we find out about dagrab
-if [ "$ONETRACK" = "y" ] ; then 
+# Decide if we can continue.
+if [ "$ONETRACK" = "y" ]; then 
+       # FIXME # remove check as soon as we find out about the other readers
        case "$CDROMREADERSYNTAX" in
-               dagrab|debug) echo "abcde error: ONETRACK reading is not suported with "$CDROMREADERSYNTAX" yet"
-                             exit 1 ;;
+               dagrab|cddafs|debug) echo "abcde error: ONETRACK reading is not suported with "$CDROMREADERSYNTAX" yet"
+                                        exit 1 ;;
        esac
        if [ "$BATCH" = "y" ]; then
                echo "abcde error: BATCH mode is not compatible with ONETRACK mode"
+               BATCH=n
        fi
        # It does not matter how many tracks we want. In ONETRACK mode we grab them all
+       # FIXME # allow ranges of tracks to be selected for onetrack ripping
        if [ $# -gt 0 ]; then
-               vecho "ONETRACK mode selected: grabbing all tracks..."
+               vecho "abcde warning: ONETRACK mode selected, grabbing all tracks..."
        fi
 else
        while [ $# -gt 0 ]; do
@@ -1914,6 +1949,40 @@ else
        done
 fi
 
+# List of valid actions: cddb,read,normalize,encode,tag,move,playlist,clean
+# List of experimental actions: retag,transcode
+
+# Determine what actions are to be done from $ACTIONS and set the
+# following environment variables for them:
+DOCDDB=n
+DOREAD=n
+DONORMALIZE=n
+DOPREPROCESS=n
+DOENCODE=n
+DOPOSTPROCESS=n
+DOTAG=n
+DOMOVE=n
+DOPLAYLIST=n
+DOCLEAN=n
+
+for ACTION in $(echo $ACTIONS | tr , \ )
+do
+       case $ACTION in
+               cddb) DOCDDB=y;;
+               read) DOREAD=y;;
+               normalize) DONORMALIZE=y; DOREAD=y;;
+#              preprocess) DOPREPROCESS=y; DOREAD=y;;
+               encode) DOENCODE=y; DOREAD=y;;
+#              postprocess) DOPREPROCESS=y; DOENCODE=y; DOREAD=y;;
+               tag) DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
+               move) DOMOVE=y; DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
+               playlist) DOCDDB=y; DOPLAYLIST=y;;
+               clean) DOCLEAN=y;;
+       esac
+done
+
+# Sanity checks:
+
 # At this point a CDROM has to be defined, so we check it exists.
 if [ "$CDROM" != "" ] ; then 
        if [ "$CDROMREADERSYNTAX" = "cdda2wav" ] && [ "$NEEDCDROMID" = "y" ] ; then
@@ -1933,6 +2002,32 @@ else
        exit 1
 fi
 
+# USEPIPES pre-tests, before we get into more serious stuff
+# Not compatible with:
+# - multiple outputs
+# - normalize
+# - lowdisk algorithm
+# - anything else?
+if [ X"$USEPIPES" = "Xy" ]; then
+       if [ $(echo $OUTPUTTYPE | tr , \  | wc -w ) -gt 1 ]; then
+               echo "abcde error: Unix pipes not compatible with multiple outputs"
+               exit 1
+       fi
+       if [ X"$DONORMALIZE" = "Xy" ]; then
+               echo "abcde error: Unix pipes not compatible with normalizer"
+               # FIXME # Do we need to exit or shall we just disable the mode?
+               exit 1
+       fi
+       if [ X"$DOENCODE" = "Xn" ]; then
+               vecho "Disabling Unix pipes since we are not encoding!"
+               USEPIPES=n
+       fi
+       if [ X"$LOWDISK" = "Xy" ]; then
+               vecho "abcde error: Unix pipes not compatible with lowdisk algorithm"
+               exit 1
+       fi
+fi
+
 # Decide which CDROM reader we're gonna use
 case "$CDROMREADERSYNTAX" in
        cdparanoia|debug)
@@ -1961,85 +2056,109 @@ case "$NORMALIZERSYNTAX" in
                ;;
 esac
 
+# Allow -o OUTPUT(1):OPTIONS(1),...,OUTPUT(N):OPTIONS(N) mode of operation
+if echo $OUTPUTTYPE | grep ":" > /dev/null 2>&1 ; then
+       OLDFS="$FS"
+       export FS=","
+       for OUTPUT in "$OUTPUTTYPE"
+       do
+               case "$OUTPUT" in
+                       ogg:*)  OGGENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
+                       mp3:*)  MP3ENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
+                       flac:*) FLACENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
+                       spx:*)  SPEEXENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
+                       mpc:*)  MPPENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
+               esac
+       done
+       for OUTPUT in "$OUTPUTTYPE"
+       do
+               TEMPOUTPUT=$( echo "$OUTPUT" | cut -d: -f1 )
+               TEMPOUTPUTTYPE="${TEMPOUTPUTTYPE:+$TEMPOUTPUTTYPE,}$TEMPOUTPUT"
+       done
+       OUTPUTTYPE="$TEMPOUTPUTTYPE"
+       FS="$OLDFS"
+fi
+
 # If nothing has been specified, use oggenc for oggs and lame for mp3s and flac for flacs and speexenc for speex and mppenc for mpps
 
 # Getting ready for multiple output changes
 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
 do
        case $OUTPUT in
-               ogg)  [ "$OGGENCODERSYNTAX" = "default" ] && OGGENCODERSYNTAX=oggenc
-                     echo $ACTIONS | grep tag > /dev/null 2>&1 && NEEDCOMMENTER=y
-                       ;;
-               mp3)  [ "$MP3ENCODERSYNTAX" = "default" ] && MP3ENCODERSYNTAX=lame
-                     echo $ACTIONS | grep tag > /dev/null 2>&1 && NEEDTAGGER=y
+               ogg)    [ "$OGGENCODERSYNTAX" = "default" ] && OGGENCODERSYNTAX=oggenc
+                               [ "$DOTAG" = "y" ] && NEEDCOMMENTER=y
+                               [ "$REPLAYGAIN" = "y" ] && NEEDVORBISGAIN=y
+                               ;;
+               mp3)    [ "$MP3ENCODERSYNTAX" = "default" ] && MP3ENCODERSYNTAX=lame
+                               [ "$DOTAG" = "y" ] && NEEDTAGGER=y
+                               ;;
+               flac)   [ "$FLACENCODERSYNTAX" = "default" ] && FLACENCODERSYNTAX=flac
+                               [ "$DOTAG" = "y" ] && NEEDMETAFLAC=y
+                               ;;
+               spx)    [ "$SPEEXENCODERSYNTAX" = "default" ] && SPEEXENCODERSYNTAX=speexenc ;;
+               mpc)    [ "$MPPENCODERSYNTAX" = "default" ] && MPPENCODERSYNTAX=mppenc ;;
+               *)      echo "abcde error: Invalid OUTPUTTYPE defined" >&2
+                       exit 1
                        ;;
-               flac) [ "$FLACENCODERSYNTAX" = "default" ] && FLACENCODERSYNTAX=flac
-                     echo $ACTIONS | grep tag > /dev/null 2>&1 && NEEDMETAFLAC=y
-                       ;;
-               spx) [ "$SPEEXENCODERSYNTAX" = "default" ] && SPEEXENCODERSYNTAX=speexenc ;;
-               mpc) [ "$MPPENCODERSYNTAX" = "default" ] && MPPENCODERSYNTAX=mppenc ;;
-               *) echo "abcde error: Invalid OUTPUTTYPE defined" >&2
-                  exit 1
-                  ;;
        esac
 done
 
 # decide which encoder
 case "$MP3ENCODERSYNTAX" in
        lame)
-               MP3ENCODEROPTS="$LAMEOPTS"
+               MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$LAMEOPTS}"
                MP3ENCODER="$LAME"
                ;;
        gogo)
-               MP3ENCODEROPTS="$GOGOOPTS"
+               MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$GOGOOPTS}"
                MP3ENCODER="$GOGO"
                ;;
        bladeenc)
-               MP3ENCODEROPTS="$BLADEENCOPTS"
+               MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$BLADEENCOPTS}"
                MP3ENCODER="$BLADEENC"
                ;;
        l3enc)
-               MP3ENCODEROPTS="$L3ENCOPTS"
+               MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$L3ENCOPTS}"
                MP3ENCODER="$L3ENC"
                ;;
        xingmp3enc)
-               MP3ENCODEROPTS="$XINGMP3ENCOPTS"
+               MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$XINGMP3ENCOPTS}"
                MP3ENCODER="$XINGMP3ENC"
                ;;
        mp3enc)
-               MP3ENCODEROPTS="$MP3ENCOPTS"
+               MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$MP3ENCOPTS}"
                MP3ENCODER="$MP3ENC"
                ;;
 esac
 case "$OGGENCODERSYNTAX" in
        vorbize)
-               OGGENCODEROPTS="$VORBIZEOPTS"
+               OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$VORBIZEOPTS}"
                OGGENCODER="$VORBIZE"
                ;;
        oggenc)
-               OGGENCODEROPTS="$OGGENCOPTS"
+               OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$OGGENCOPTS}"
                OGGENCODER="$OGGENC"
                ;;
 esac
 case "$FLACENCODERSYNTAX" in
        flac)
-               FLACENCODEROPTS="$FLACOPTS"
+               FLACENCODEROPTS="${FLACENCODEROPTSCLI:-$FLACOPTS}"
                FLACENCODER="$FLAC"
                ;;
 esac
 case "$SPEEXENCODERSYNTAX" in
        speexenc)
-               SPEEXENCODEROPTS="$SPEEXENCOPTS"
+               SPEEXENCODEROPTS="${SPEEXENCODEROPTSCLI:-$SPEEXENCOPTS}"
                SPEEXENCODER="$SPEEXENC"
                ;;
 esac
 case "$MPPENCODERSYNTAX" in
        mppenc)
-               MPPENCODEROPTS="$MPPENCOPTS"
+               MPPENCODEROPTS="${MPPENCODEROPTSCLI:-$MPPENCOPTS}"
                MPPENCODER="$MPPENC"
                ;;
 esac
-
+               
 # and which tagger
 
 if [ "$ID3TAGV" = "1" ]; then
@@ -2064,9 +2183,10 @@ fi
 
 # Don't check for stuff if it's not needed
 if [ "$REMOTEHOSTS" ]; then NEEDDISTMP3=y; fi
-if echo $ACTIONS | grep normalize > /dev/null 2>&1 ; then NEEDNORMALIZER=y; fi
-if [ "$EJECTCD" = "y" ]; then NEEDEJECT=y; fi
-if echo $ACTIONS | grep cddb > /dev/null 2>&1 ; then NEEDHTTPGET=y ; fi
+[ "$DONORMALIZE" = "y" ] && NEEDNORMALIZER=y
+[ "$EJECTCD" = "y" ] && NEEDEJECT=y
+[ ! "$CDDBAVAIL" = "n" ] && [ "$DOCDDB" = "y" ] && NEEDHTTPGET=y
+[ "$CUEFILE" = "y" ] && NEEDMKCUE=y
 
 if [ X"$CDSPEEDVALUE" != "X" ]; then
        case "$CDROMREADERSYNTAX" in
@@ -2075,6 +2195,45 @@ if [ X"$CDSPEEDVALUE" != "X" ]; then
        esac
 fi
 
+# Rippers with USEPIPE support
+# FIXME # Include here all the rippers we can figure out support pipes
+PIPE_cdparanoia="-"
+
+# Encoders with USEPIPE support
+# FIXME # Include here all the encoders we can figure out support pipes
+PIPE_lame="-"
+PIPE_oggenc="-"
+
+# Figure out if we can use pipes with the ripper/encoder combination
+# exit otherwise
+if [ "$USEPIPES" = "y" ]; then
+       PIPERIPPERSVARCHECK="PIPE_${CDROMREADER}"
+       case "$OUTPUT" in
+               mp3)
+                       PIPEENCODERSVARCHECK="PIPE_$MP3ENCODERSYNTAX" ;;
+               ogg)
+                       PIPEENCODERSVARCHECK="PIPE_$OGGENCODERSYNTAX" ;;
+               flac)
+                       PIPEENCODERSVARCHECK="PIPE_$FLACENCODERSYTNAX" ;;
+               spx)
+                       IPEENCODERSVARCHECK="PIPE_$SPEEXENCODER" ;;
+               mpc)
+                       PIPEENCODERSVARCHECK="PIPE_$MPPENCODER" ;;
+       esac
+       if [ ! -n "${!PIPERIPPERSVARCHECK}" ] ; then
+               echo "abcde error: no support for pipes with given ripper" >&2
+               echo "read the USEPIPES file from the source tarball to help" >&2
+               echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
+               exit 1;
+       fi
+       if [ ! -n "${!PIPEENCODERSVARCHECK}" ] ; then
+               echo "abcde error: no support for pipes with given encoder" >&2
+               echo "read the USEPIPES file from the source tarball to help" >&2
+               echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
+               exit 1;
+       fi
+fi
+
 
 # Make sure a buncha things exist
 for X in $CDROMREADER $CDDISCID ${NEEDTAGGER+$TAGGER} $MP3ENCODER \
@@ -2082,7 +2241,8 @@ for X in $CDROMREADER $CDDISCID ${NEEDTAGGER+$TAGGER} $MP3ENCODER \
        ${NEEDHTTPGET+$HTTPGET} ${NEEDDISTMP3+$DISTMP3} \
        ${NEEDCOMMENTER+$VORBISCOMMENT} ${NEEDMETAFLAC+$METAFLAC} \
        ${NEEDNORMALIZER+$NORMALIZER} ${NEEDEJECT+$EJECT} \
-       ${NEEDDISKTOOL+disktool} ${NEEDCDSPEED+$CDSPEED}
+       ${NEEDDISKTOOL+disktool} ${NEEDCDSPEED+$CDSPEED} \
+       ${NEEDVORBISGAIN+$VORBISGAIN} ${NEEDMKCUE+$MKCUE}
 do
        # Cut off the command-line options we just added in
        X=$(echo $X | cut -d' ' -f2)
@@ -2099,9 +2259,9 @@ CDROMREADER="$CDROMREADER $CDROMREADEROPTS"
 CDDBTOOL="$CDDBTOOL $CDDBTOOLOPTS"
 HTTPGET="$HTTPGET $HTTPGETOPTS"
 
-# One thousand seven hundred lines in, we can start doing stuff with things
-
-# List of valid actions: cddb,playlist,read,normalize,encode,tag,move
+# Here it used to say:
+# One thousand lines in, we can start doing stuff with things
+# Well, right now we are at line 2157 ;)
 
 # Export needed things so they can be read in this subshell
 export CDDBTOOL ABCDETEMPDIR TRACKQUEUE LOWDISK EJECTCD EJECT EJECTOPTS
@@ -2122,11 +2282,14 @@ if [ "$DOCDDB" = "y" ]; then
        if [ $CDDBUSELOCAL = "y" ]; then
                do_localcddb
        fi
-       ## FIXME ## ! is non-portable
-       if ! checkstatus cddb-choice > /dev/null && [ ! "$CDDBLOCALSUCCESS" = "y" ] ; then
-               do_cddbstat
-               do_cddbquery
-               do_cddbread
+       if checkstatus cddb-choice > /dev/null; then
+               :
+       else 
+               if [ ! "$CDDBLOCALSUCCESS" = "y" ] ; then
+                       do_cddbstat
+                       do_cddbquery
+                       do_cddbread
+               fi
        fi
        do_cddbedit
 
@@ -2142,42 +2305,11 @@ if [ X"$CDSPEEDVALUE" != "X" ]; then
        esac
 fi
 
-if [ "$STRIPDATATRACKS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
-       case "$CDROMREADERSYNTAX" in
-               cdparanoia|debug) 
-                       # cdparanoia can query the CD, so let's process the TRACKQUEUE list with the results.
-                       if checkstatus cdparanoia-audio-tracks; then
-                               CDTRACKQUEUE=$( cat $ABCDETEMPDIR/cdparanoia-audio-tracks )
-                       else
-                               ## FIXME ##
-                               vecho "Querying the CD to obtain a list of valid audio tracks..."
-                               $CDROMREADER -Q > $ABCDETEMPDIR/cdparanoia-query 2>&1
-                               # Obtain a list of valid audio tracks from the results of the query
-                               CDTRACKQUEUE=$( cat $ABCDETEMODIR/cdparanoia- | egrep '^[[:space:]]+[[:digit:]]' | awk '{print $1}' | tr -d "." | tr '\n' ' ' )
-                       fi
-                       # Obtain the track padding value from the before-processing list and pad the CD list
-                       TRACKNUMPADDING=$( echo $TRACKQUEUE | awk '{print $1}' | tr -d " \n" | wc -c )
-                       for TRACK in $CDTRACKQUEUE ; do
-                               TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${TRACK} + 0 ))
-                               PADNEWTRACKQUEUE=$(echo $PADNEWTRACKQUEUE $TRACKNUM)
-                       done
-                       CDTRACKQUEUE=$PADNEWTRACKQUEUE
-                       # Now, compare if the values in the list are valid tracks in the CD
-                       for TRACK in $TRACKQUEUE; do
-                               if echo $CDTRACKQUEUE | grep $TRACK >/dev/null ; then
-                                       NEWTRACKQUEUE="$NEWTRACKQUEUE $TRACK"
-                               fi
-                       done
-                       TRACKQUEUE="$NEWTRACKQUEUE"
-               ;;
-       esac
-fi
-
 # Create playlist if needed (backgroundable) and start reading in tracks
 
 (
 
-if [ "$ONETRACK" = "y" ]; then :; else
+if [ ! "$ONETRACK" = "y" ]; then
        if [ "$DOPLAYLIST" = "y" ]; then
                echo Creating playlist... >&2
                do_playlist
@@ -2195,14 +2327,20 @@ if [ "$ONETRACK" = "y" ]; then
        TRACKS="$FIRSTTRACK"
        for UTRACKNUM in $TRACKQUEUE; do :;done
        if checkstatus readtrack-$FIRSTTRACK; then :; else
-               do_cdread_one $UTRACKNUM $FIRSTTRACK
+               do_cdread onetrack $FIRSTTRACK $UTRACKNUM
        fi
 else
        for UTRACKNUM in $TRACKQUEUE
        do
                if [ "$DOREAD" = "y" ]; then
-                       if checkstatus readtrack-$UTRACKNUM; then :; else
-                               do_cdread $UTRACKNUM
+                       if [ "$USEPIPES" = "y" ]; then
+                               if checkstatus readencodetrack-$UTRACKNUM; then :; else
+                                       do_cdread $UTRACKNUM | do_encode $UTRACKNUM %local0%
+                               fi
+                       else
+                               if checkstatus readtrack-$UTRACKNUM; then :; else
+                                       do_cdread $UTRACKNUM
+                               fi
                                if [ "$?" != "0" ]; then
                                        # CD read failed - don't give the goahead to
                                        # the encoder
@@ -2332,7 +2470,7 @@ do
        read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
        if [ "$GOAHEAD" = "NO" ]; then break; fi
        # find out where this track is to be encoded
-       if [ "$DOENCODE" = "y" ]; then
+       if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
                # Make sure we have a place to encode this, if not, exit stage right
                if [ -z "$ENCODELOCATIONS" ]; then
                        continue
@@ -2381,7 +2519,7 @@ do
 #                      TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${UTRACKNUM} + 0))
                        TRACKNUM=$UTRACKNUM
                        CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
-                       TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
+                       TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2 -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')
                        splitvarious
                fi
        fi
@@ -2394,7 +2532,7 @@ do
                        if checkstatus normalizetrack-$UTRACKNUM; then :; else do_normalize $UTRACKNUM; fi
                fi
        fi
-       if [ "$DOENCODE" = "y" ]; then
+       if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
                if checkstatus readtrack-$UTRACKNUM; then
                        #if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION; fi
                        if [ "$DONORMALIZE" = "y" ]; then
@@ -2420,7 +2558,8 @@ do
 done
 # Go through it again and make sure there's no distmp3 stragglers, otherwise
 # we'll delete the files they're working on
-if [ "$DOENCODE" = "y" ]; then
+## FIXME ## Check also for files which are encoded using PIPEs.
+if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
        PROCEED=
        until [ $PROCEED ]
        do
@@ -2465,3 +2604,6 @@ else
 fi
 )
 exit 0
+
+# b:is_bash
+# vim:tabstop=4